#ifndef _CHANNEL_H
#define _CHANNEL_H

#include <QList>
#include "samples.h"

typedef QList<Samples *> ChannelList;

class Channel : public ChannelList {
private:
	int _samplerate;
	int _channels;
	int _samplesize;

public:
	void write(char *path) const;
	void ltrim(double value);
	void rtrim(double value);
	void clear();

	int channels() const;
	void setChannels(int value);
	int samplesize() const;
	void setSamplesize(int value);
	int samplerate() const;
	void setSamplerate(int value);
	size_t nsamples() const;
	size_t pos(Samples *samples);
	double posT(Samples *samples);
	double duration(int nsamples) const;
	double duration(Samples *samples) const;
	double duration() const;
	void mul(double value);
	void limits(int &min, int &max) const;
	int absmax() const;
	int maxval() const;

	Channel(int samplerate = 44100, int channels = 1, int samplessize = 2);
};

#endif

