#ifndef _CODEC_FLAC_H
#define _CODEC_FLAC_H

#include "codec.h"

#include <FLAC++/decoder.h>
#include <FLAC++/encoder.h>
#include <QString>

#include "channel.h"
#include "tag.h"

class DecoderFlac : public Decoder, private FLAC::Decoder::File {
private:
	FLAC__StreamDecoderInitStatus err;

	FLAC__StreamDecoderWriteStatus write_callback(const FLAC__Frame *frame, const FLAC__int32 * const data[]);
	void error_callback(FLAC__StreamDecoderErrorStatus status);
	void metadata_callback(const FLAC__StreamMetadata *metadata);

public:
	bool open(std::string const path);
	bool open(FILE *f);
	bool decode(Channel &channel);

	DecoderFlac();
};

class EncoderFlac : private FLAC::Encoder::File {
private:
	FLAC__StreamMetadata *metadata[2];

	FLAC__StreamEncoderInitStatus init_status;

public:
	bool init(Channel &channel);
	bool setTag(Tag const &tag);
	bool open(QString const path);
	bool open(FILE *f);
	bool encode(Channel &channel);

	EncoderFlac();
};

#endif
