#ifndef _CUTTER_WIDGET_H
#define _CUTTER_WIDGET_H

#include <QFrame>
#include <QPainter>

#include "cutter.h"
#include "tag.h"

class CutterWidget : public QFrame, public Cutter {
	Q_OBJECT

private:
	int factor;
	double factorT;
	QString target;

signals:
	void updated();
	void terminated();
	void changeState();

public slots:
	void refresh();

private:
	void paintThreshold(QPainter &painter, int h, int w);
	void paintArea(QPainter &painter, double t, double duration, int h, QColor color);

protected:
	void addSamples(Samples *samples);
	void _save();
	void terminate();

	void mousePressEvent(QMouseEvent *);
	void paintEvent(QPaintEvent *);
	QSize sizeHint() const;
	int height() const;

public:
	void setTarget(QString value);
	bool begin();
	bool end();
	Tag tag;

	void setThresholdStart(double value);
	void setThresholdSilence(double value);
	void setThresholdSaturation(double value);

	CutterWidget(QWidget *parent);
	~CutterWidget();
};

#endif
