#ifndef _FILE_H
#define _FILE_H

#include <QVector>
#include <QString>
#include <QXmlDefaultHandler>

#include "tag.h"
#include "recorder_item.h"

class FileItems : public QVector<RecorderItemData *> {
public:
	void writeXml(QXmlStreamWriter &stream) const;
	void debug() const;
};

class File {
public:
	Tag tag;
	FileItems items;

public:
	bool readXml(QXmlInputSource *source);
	bool read(QString path);
	void write(QXmlStreamWriter &stream) const;
	void write(QString fileName) const;

	void debug() const;
	void clear();
	~File();
};

class FileHandler : public QXmlDefaultHandler {
private:
	File *file;
public:
	bool startElement(const QString &namespaceURI, const QString &localName, const QString &qName, const QXmlAttributes &attributes);
	bool fatalError(const QXmlParseException &exception);

	FileHandler(File *file);
};

#endif


