/*
 *   Copyright (C) 2010 Association Shtooka <dev-public@shtooka.net>
 *
 *   This file is part of swac-record.
 * 
 *   Swac-record is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   
 *   Swac-record is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with Swac-record.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MODEL_ITEMS_H
#define _MODEL_ITEMS_H

#include <QAbstractItemModel>
#include <QXmlDefaultHandler>
#include <QVector>
#include <QComboBox>

class ModelItem {
public:
	QString value;
	QString name;

	ModelItem(QString value, QString name);
};

class ModelItems : public QAbstractListModel {
private:
	QVector<ModelItem *> items;

public:
	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;

public:
	void parseXml(QString const path);
	void add(QString value, QString name);
	ModelItems();
};

class ModelItemsParser : public QXmlDefaultHandler {
private:
	ModelItems *modelItems;
public:
	bool startElement(const QString&, const QString&, const QString &qName, const QXmlAttributes &attributes);

	ModelItemsParser(ModelItems *modelItems);
};

class ItemsComboBox : public QComboBox {
public:
	QString currentValue() const;
	void setValue(QString value);
};

#endif
