#ifndef _RECORDER_H
#define _RECORDER_H

#include <portaudio.h>
#include <QObject>
#include <QString>

#include "samples.h"

class Recorder {
private:

	PaStreamParameters inputParameters;
	PaStream *stream;

	int device;
	unsigned int samplerate;

	virtual void addSamples(Samples *samples);
	int callback(const void *inputBuffer, void *outputBuffer, unsigned long framesPerBuffer, const PaStreamCallbackTimeInfo* timeInfo, PaStreamCallbackFlags statusFlags);
	static int static_callback(const void *inputBuffer, void *outputBuffer, unsigned long framesPerBuffer, const PaStreamCallbackTimeInfo* timeInfo, PaStreamCallbackFlags statusFlags, void *userData);

public:
	static int deviceCount();
	static QString deviceName(int i);
	void setDevice(int value);
	int getDevice() const;
	void info();
	bool init();
	bool setup();
	bool begin();
	bool end();
	bool isActive();
	unsigned int getSamplerate() const;
	bool setSamplerate(unsigned int value);

	Recorder();
};

#endif

