#ifndef _SAMPLES_H
#define _SAMPLES_H

#include <stdlib.h>
#include <stdio.h>

#define MIN(a, b) (a < b ? a : b)
#define MAX(a, b) (a < b ? b : a)

class Samples {
protected:
	size_t _capacity;
	size_t _nsamples;
	bool _limits;
	int _min, _max;	

public:
	void debug() const;
	size_t nsamples() const;
	int absmax();
	void limits(int &min, int &max);

	virtual size_t append(Samples &src) = 0;
	virtual int get(size_t n) const = 0;
	virtual void set(size_t n, int value) = 0;
	virtual size_t size() const = 0;
	virtual void *data() const = 0;
	virtual void setCapacity(size_t value) = 0;
	virtual void limitsDo(int &min, int &max) const = 0;
	virtual void mul(double value) = 0;
	virtual void write(FILE *f) const = 0;
	virtual int maxval() const = 0;

	Samples();
	virtual ~Samples();
};

template <typename T>
class TSamples : public Samples {
protected:
	T *_data;

public:
	int get(size_t n) const;
	void set(size_t n, int value);
	size_t size() const;
	void *data() const;
	void setCapacity(size_t value);
	size_t append(T const *src, size_t s);
	size_t append(Samples &src);
	size_t append(T const value, size_t s = 1);
	void limitsDo(int &min, int &max) const;
	void mul(double value);
	void write(FILE *f) const;
	int maxval() const;

	TSamples();
	~TSamples();
};

#endif

