#ifndef _SETUP_AUDIO_H
#define _SETUP_AUDIO_H

#include <QDoubleSpinBox>
#include <QSpinBox>
#include <QDialogButtonBox>
#include <QPushButton>
#include <QAbstractListModel>
#include <QVariant>
#include <QComboBox>
#include <QCheckBox>

#include "cutter_widget.h"

class SetupAudio : public QWidget {
	Q_OBJECT

private:
	CutterWidget *cutter;

	QComboBox *samplerate;
	QSpinBox *startThreshold;
	QSpinBox *stopThreshold;
	QSpinBox *saturationThreshold;
	QDoubleSpinBox *stopSilence;
	QDoubleSpinBox *marginBefore;
	QDoubleSpinBox *marginAfter;
	QCheckBox *normalize;

	QComboBox *deviceList;

public:
	void getValues();
	void setValues();

public:
	SetupAudio(CutterWidget *cutter);
};

class DeviceModel : public QAbstractListModel {
private:
	Recorder *recorder;

public:
	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const;

	DeviceModel(Recorder *recorder);
};

#endif
