#include "tag.h"

#include <QDebug>

TagItem::TagItem(QString _name, QString _value) : name(_name), value(_value) {
}

void TagItem::writeXmlAttribute(QXmlStreamWriter &stream) const {
	stream.writeAttribute(name, value);
}

void TagItem::debug() const {
	qDebug() << name << "=" << value;
}

void Tag::add(QString name, QString value) {
	push_back(TagItem(name, value));
}

void Tag::debug() const {
	for(const_iterator it = begin(); it != end(); it++) {
		it->debug();
	}
}

void Tag::writeXmlAttributes(QXmlStreamWriter &stream) const {
	for(const_iterator it = begin(); it != end(); it++) {
		it->writeXmlAttribute(stream);
	}
}

void Tag::readXmlAttributes(QXmlAttributes const &attributes) {
	for (int i = 0; i < attributes.count(); i++) {
		add(attributes.qName(i), attributes.value(i));
	}
}

QString Tag::get(QString name) const {
	for (const_iterator it = begin(); it != end(); it++) {
		if (it->name == name)
			return it->value;
	}
	return NULL;
}

QString &Tag::getVar(QString name) {
	for (iterator it = begin(); it != end(); it++) {
		if (it->name == name)
			return it->value;
	}

	push_back(TagItem(name, ""));
	return last().value;
}
