#ifndef _TAG_H
#define _TAG_H

#include <QString>
#include <QList>
#include <QXmlStreamWriter>
#include <QXmlAttributes>

class TagItem {
public:
	QString name;
	QString value;

public:
	void writeXmlAttribute(QXmlStreamWriter &stream) const;
	void debug() const;
	TagItem(QString name, QString value);
};

class Tag : public QList<TagItem> {
public:
	void writeXmlAttributes(QXmlStreamWriter &stream) const;
	void readXmlAttributes(QXmlAttributes const &attributes);
	void debug() const;
	void add(QString name, QString value);
	QString get(QString name) const;
	QString &getVar(QString name);
};

#endif
