#ifndef _WINDOW_SETUP_H
#define _WINDOW_SETUP_H

#include <QDialog>
#include <QTabWidget>
#include <QDialogButtonBox>
#include <QPushButton>

#include "setup_audio.h"
#include "setup_view.h"

class WindowSetup : public QDialog {
	Q_OBJECT

private:
	SetupAudio *setupAudio;
	SetupView *setupView;

	QTabWidget *tabWidget;
	QDialogButtonBox *buttonBox;
	QPushButton *buttonOk;
	QPushButton *buttonApply;
	QPushButton *buttonCancel;

private slots:
	void apply();
	void ok();

public:
	WindowSetup(CutterWidget *cutter, RecorderView *recorderView);
};

#endif
